VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsThreads"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsThreads
' DateTime  : 23/11/2006 14:42
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Gerer les threads
'---------------------------------------------------------------------------------------

Option Explicit


'---------------------------------------------------------------------------------------
' Procedure : ListThreads
' DateTime  : 23/11/2006 15:50
' Author    : Vb System Library
' Purpose   : Fait la liste de tous les threads qui s'executent sur le systme
' Params    : tabThreadID() : Tableau contenant la liste des ID des threads
'---------------------------------------------------------------------------------------
Public Sub ListThreads(ByRef tabThreadID() As Long)
    Dim hSnapshot As Long
    Dim Thread As THREADENTRY32, Compteur As Long
    ReDim tabThreadID(0) As Long
    Compteur = 0
    ' On cre une capture des threads du systme
    hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0&)
    Thread.dwSize = Len(Thread)
    ' On prend le premier
    If Thread32First(hSnapshot, Thread) Then
        Thread.dwSize = Len(Thread)
        ' On parcourt tous les threads existants
        Do
            ReDim Preserve tabThreadID(Compteur) As Long
            ' On le liste
            tabThreadID(Compteur) = Thread.th32ThreadID
            Compteur = Compteur + 1
        Loop While Thread32Next(hSnapshot, Thread)
    End If
    CloseHandle hSnapshot
End Sub


'---------------------------------------------------------------------------------------
' Procedure : SuspendThread
' DateTime  : 07/02/2007 21:15
' Author    : Vb System Library
' Purpose   : Suspend un thread
' Params    :
'---------------------------------------------------------------------------------------
Public Function SuspendThread(ByVal ThreadID As Long)
    Dim hThread As Long
    ' Renvoie le handle du thread "ouvert" (pour agir dessus)
    hThread = OpenThread(THREAD_ALL_ACCESS, 0, ThreadID)
    ' Suspend le thread
    SuspendThread hThread
    ' Ferme le handle
    CloseHandle hThread
End Function


'---------------------------------------------------------------------------------------
' Procedure : ResumeThread
' DateTime  : 07/02/2007 21:15
' Author    : Vb System Library
' Purpose   : Reprendre un thread (qui a t suspendu)
' Params    :
'---------------------------------------------------------------------------------------
Public Function ResumeThread(ByVal ThreadID As Long)
    Dim hThread As Long
    ' Renvoie le handle du thread "ouvert" (pour agir dessus)
    hThread = OpenThread(THREAD_ALL_ACCESS, 0, ThreadID)
    ' Reprend le thread
    ResumeThread hThread
    ' Ferme le handle
    CloseHandle hThread
End Function
